Package org.codehaus.groovy.classgen.asm

# Class CallSiteWriter

java.lang.Object
org.codehaus.groovy.classgen.asm.CallSiteWriter

Direct Known Subclasses:
  `IndyCallSiteWriter`, `StaticTypesCallSiteWriter`

    public class CallSiteWriter
    extends Object

This class represents non public API used by AsmClassGenerator. Don't use this class in your code

- ## Field Summary

  Fields
  Modifier and Type | Field | Description
  --- | --- | ---
  `static String` | `CONSTRUCTOR` |

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `CallSiteWriter​(WriterController wc)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `fallbackAttributeOrPropertySite​(PropertyExpression expression, Expression objectExpression, String name, MethodCallerMultiAdapter adapter)` |
  `void` | `generateCallSiteArray()` |
  `List<String>` | `getCallSites()` |
  `boolean` | `hasCallSiteUse()` |
  `void` | `makeCallSite​(Expression receiver, String message, Expression arguments, boolean safe, boolean implicitThis, boolean callCurrent, boolean callStatic)` |
  `void` | `makeCallSiteArrayInitializer()` |
  `void` | `makeGetPropertySite​(Expression receiver, String methodName, boolean safe, boolean implicitThis)` |
  `void` | `makeGroovyObjectGetPropertySite​(Expression receiver, String methodName, boolean safe, boolean implicitThis)` |
  `void` | `makeSingleArgumentCall​(Expression receiver, String message, Expression arguments)` |
  `void` | `makeSingleArgumentCall​(Expression receiver, String message, Expression arguments, boolean safe)` |
  `void` | `makeSiteEntry()` |
  `void` | `prepareCallSite​(String message)` |
  `protected void` | `prepareSiteAndReceiver​(Expression receiver, String methodName, boolean implicitThis, boolean lhs)` |
  `protected void` | `visitBoxedArgument​(Expression exp)` |

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### CONSTRUCTOR

    public static final String CONSTRUCTOR
    See Also:
      Constant Field Values

- ## Constructor Details

  - ### CallSiteWriter

    public CallSiteWriter​(WriterController wc)

- ## Method Details

  - ### makeSiteEntry

    public void makeSiteEntry()

  - ### generateCallSiteArray

    public void generateCallSiteArray()

  - ### prepareCallSite

    public void prepareCallSite​(String message)

  - ### prepareSiteAndReceiver

    protected void prepareSiteAndReceiver​(Expression receiver, String methodName, boolean implicitThis, boolean lhs)

  - ### visitBoxedArgument

    protected void visitBoxedArgument​(Expression exp)

  - ### makeSingleArgumentCall

    public final void makeSingleArgumentCall​(Expression receiver, String message, Expression arguments)

  - ### makeSingleArgumentCall

    public void makeSingleArgumentCall​(Expression receiver, String message, Expression arguments, boolean safe)

  - ### makeGroovyObjectGetPropertySite

    public void makeGroovyObjectGetPropertySite​(Expression receiver, String methodName, boolean safe, boolean implicitThis)

  - ### makeGetPropertySite

    public void makeGetPropertySite​(Expression receiver, String methodName, boolean safe, boolean implicitThis)

  - ### makeCallSite

    public void makeCallSite​(Expression receiver, String message, Expression arguments, boolean safe, boolean implicitThis, boolean callCurrent, boolean callStatic)

  - ### getCallSites

    public List<String> getCallSites()

  - ### makeCallSiteArrayInitializer

    public void makeCallSiteArrayInitializer()

  - ### hasCallSiteUse

    public boolean hasCallSiteUse()

  - ### fallbackAttributeOrPropertySite

    public void fallbackAttributeOrPropertySite​(PropertyExpression expression, Expression objectExpression, String name, MethodCallerMultiAdapter adapter)